import { IInjectionInstance, ProviderToken, RegistrationProvider } from './interfaces';
import { IContainer } from './container.interface';
export declare class Container implements IContainer {
    private parent;
    private registry;
    constructor(parent?: IContainer | undefined);
    register(provider: RegistrationProvider | RegistrationProvider[]): void;
    resolve(token: ProviderToken): IInjectionInstance;
    createScope(): IContainer;
    setParent(parent: IContainer): void;
    createChild(): IContainer;
    private resolveInternal(token, traceMessage?);
    private registerAll(providers);
    private registerOne(provider);
    private createInstance(cls, message);
    private nornalizeProvider(provider);
    private normalizeSingleProvider(provider);
    private buildTraceMessage(token, message);
    private getTokenString(token);
    private symbol2string(symbol);
    private isInjectable(cls);
    private getInjections(cls);
}
