"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const keys_1 = require("./metadata/keys");
const index_1 = require("./metadata/index");
const MetadataAnnotator = index_1.AnnotatorProvider.get();
function Injectable(injections) {
    return (target) => {
        MetadataAnnotator.defineMetadata(keys_1.INJECTABLE_MD_KEY, true, target);
        if (injections && Array.isArray(injections)) {
            const injectionMd = MetadataAnnotator.getMetadata(keys_1.INJECTIONS_MD_KEY, target) || [];
            injections.forEach((injectionToken, injectionIndex) => {
                injectionMd.push({
                    token: injectionToken,
                    parameterIndex: injectionIndex
                });
            });
            MetadataAnnotator.defineMetadata(keys_1.INJECTIONS_MD_KEY, injectionMd, target);
        }
    };
}
exports.Injectable = Injectable;
function Inject(token) {
    return (target, propertyKey, parameterIndex) => {
        const injections = MetadataAnnotator.getMetadata(keys_1.INJECTIONS_MD_KEY, target) || [];
        injections.push({
            token,
            parameterIndex
        });
        MetadataAnnotator.defineMetadata(keys_1.INJECTIONS_MD_KEY, injections, target);
    };
}
exports.Inject = Inject;
