"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class InvalidProviderProvidedError extends Error {
    constructor() {
        super('Invalid Provider was provided');
    }
}
exports.InvalidProviderProvidedError = InvalidProviderProvidedError;
class ClassNotInjectableError extends Error {
    constructor(constructorName) {
        super(`Class ${constructorName} is not injectable`);
    }
}
exports.ClassNotInjectableError = ClassNotInjectableError;
class NoProviderError extends Error {
    constructor(token, traceMessage) {
        super(`No provider for ${token}. ${traceMessage}`);
    }
}
exports.NoProviderError = NoProviderError;
